# Шаблоны

**ВАЖНО**. *Только для компонент, [структура (дерево) которых была создана](Создание-и-использование-UI-компонент.md) с помощью [хелпера `define_component`](Хелпер-define_component.md) доступно использование BEMHTML шаблонов.*

**ВАЖНО**. *Шаблоны должны быть максимально простыми и не содержать излишней логики.*

Каждый шаблон, например, `template.elem(:message).replace 'Plain text'` состоит из:
1. `elem(:message)` - [предикат](Предикаты.md)
1. `replace` - [режим](Режимы.md)
1. `'Plain text'` - тело

Если для узла из структуры (дерева) компонента, все условия в предикате верны, тогда для этого узла будет применено тело шаблона в указанном режиме изменения данных.

Шаблоны можно создавать используя хелперы `define_templates`, `render_component` и  `refine_component`.

## Примеры шаблонов

### Шаблоны по умолчанию для компонента из файла `index.bemhtml.slim`

```slim
= define_templates do |template|
  = template.block(:panel).add_cls :panel_default
```

### Шаблоны при использовании `render_component`

```slim
= render_component :alert do |template|
  = template.block(:alert).add_cls :alert_info
  = template.elem(:message).content do |node, builder|
    span HTML content
    = node.content
    = builder.text TextNode content
```

### Шаблоны при использовании `refine_component`

```slim
= refine_component :progress do |template|
  = template.block(:progress).content do |node|
    = node.content
    = node.content
    = node.content
```
