# frozen_string_literal: true

RSpec.describe 'block_tag helper' do
  delegate :block_tag, to: :view

  subject(:html_entity_tree_builder_method) { view.method(:block_tag) }

  [true, false].each do |bem|
    context "when bem is globally set to #{bem}" do
      before do
        Bemer.config.bem = bem
      end

      ['', nil, false].each do |name|
        context 'when no additional parameters are passed' do
          # let(:html_entity_tree) do
          #   block_tag :hello, tag: :span, js: true
          # end

          let(:content) do
            Proc.new do |block|
              block.elem :ttetet, content: 'Hello', js: true
            end
          end

          let(:html) do
            <<-HTML
              <div>
                <span class="hdhf i-bem" data-bem="{&quot;hello&quot;:{}}">Heloo  HHH</span>
              </div>
            HTML
          end
          # it 'creates an empty div element' do
          #   html = block_tag.call(name)

          #   expect(html).to eq '<div></div>'
          # end
          # it_behaves_like 'a BEM entity', '<div></div>'
          # it_behaves_like 'a block entity builder method', 'Helloo', :yeyeye
          # it_behaves_like 'an entity builder method', 'html'
          # it_behaves_like 'an HTML entity tree builder method', :hello, { tag: :strong }, 'html'
        end
      end

      context 'when the block name is not empty' do
        context 'when the bem parameter is passed' do
          # let(:content) do
          #   Proc.new do |block|
          #     block.elem :ttetet
          #   end
          # end

          # it_behaves_like 'a BEM entity', '<div></div>', :block_name, tag: :p

          # it 'sdf' do
          #   html = block_tag.call(:name) do |block|
          #     block.elem :jj
          #   end

          #   expect(html).to eq '<div></div>'
          # end
        end
      end

      # it 'displays product details correctly' do
      #   p '=' * 30
      #   p Bemer.config
      #   p '=' * 30
      #   p block_tag.call :hello
      #   p view.block_tag
      #   # p view.render template: 'say/hello', locals: { say: :hello }

      #   # html = view.render_component(:hello, say: :hello) do |template|
      #   #   template.block(:hello).js true
      #   # end
      #   # p html
      #   # p ActionController::Base.new.view_context
      #   # expect(html).to eq '<div class="hello i-bem" data-bem="{&quot;hello&quot;:{}}"></div>'
      #   # p rendered
      # end
    end
  end
end
